#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
in vec2 texCoord1;
in vec4 normal;

out vec4 fragColor;

void main() {
    vec4 rawcolor = texture(Sampler0, texCoord0);
    vec4 color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator;
    if ((rawcolor.a < 1 && rawcolor.a > 0.97) || (rawcolor.a < 0.5 && rawcolor.a > 0.48) || (rawcolor.a < 0.3 && rawcolor.a > 0.28)) {
        color = texture(Sampler0, texCoord0) * vec4(1.0,1.0,1.0,1.0) * ColorModulator;
    }
    if (color.a < 0.1) {
        discard;
    }
    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}