#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;
uniform float GameTime;

uniform vec2 ScreenSize;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;

flat in int p;

out vec4 fragColor;

#moj_import <effect_utils.glsl>

void main() {
    vec4 color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator;

    if (p != 0)
    {
        vec2 centerUV = gl_FragCoord.xy / ScreenSize - 0.5;
        switch (p)
        {
            case 2: //Cut
            {
                color = vec4(0, 0, 0, 1);
                
                if (abs(centerUV.y) * 2 < 1 - mix(vertexColor.r, vertexColor.b, vertexColor.a))
                {
                    discard;
                }
                break;
            }
            case 3: //Blink
            {
                color = vec4(0, 0, 0, clamp(length(centerUV * vec2(0.8, 0.5 / (1 - vertexColor.a))) - 0.6, 0, 1));
                break;
            }
            case 4: //Red vignette
            {
                color = vec4(0.8, 0, 0, length(centerUV) * vertexColor.a);
                break;
            }
        }
    }

    if (color.a < 0.001) {
        discard;
    }

    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
